
// Verbpo.cpp : 定义应用程序的类行为。
//

#include "stdafx.h"
#include "Verbpo.h"
#include "VerbpoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CString CVerbpoApp::m_csVersion=_T("V 1.00");
// CVerbpoApp


BEGIN_MESSAGE_MAP(CVerbpoApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CVerbpoApp 构造

CVerbpoApp::CVerbpoApp()
{
	// 支持重新启动管理器
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;
	m_i32Show = 0;

	m_i32HR=30;
	m_i32ST1 = 0, m_i32ST2 = 0;
	m_u8LeadOff = 0;
	m_u8ARRA = 0;
	
	
	m_i16RR = 15;
	//窒息报警
	m_u8APNEA = 0;

	m_i32SPO2=100;
	m_i32PR = 30;
	//血氧报警
	m_u8SPO2Alm = 0;

	m_i16Temp = 371;
	m_u8TempAlm = 0;

	m_i32SBP = 100;
	m_i32DBP = 80;
	m_i32NIBP = 0;

	m_i8AirOxy = 30;
	m_i8AirOxyAlm = 0;

	m_i32AlmLock = 0;
	// TODO:  在此处添加构造代码，
	// 将所有重要的初始化放置在 InitInstance 中
}


// 唯一的一个 CVerbpoApp 对象

CVerbpoApp theApp;

const GUID CDECL BASED_CODE _tlid =
		{ 0x8C87B435, 0xACCD, 0x4B3A, { 0xBF, 0x9B, 0x1D, 0xA2, 0x8D, 0xDF, 0xD9, 0xD7 } };
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;


// CVerbpoApp 初始化

BOOL CVerbpoApp::InitInstance()
{
	// 如果一个运行在 Windows XP 上的应用程序清单指定要
	// 使用 ComCtl32.dll 版本 6 或更高版本来启用可视化方式，
	//则需要 InitCommonControlsEx()。  否则，将无法创建窗口。
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// 将它设置为包括所有要在应用程序中使用的
	// 公共控件类。
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}


	// 初始化 OLE 库
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// 创建 shell 管理器，以防对话框包含
	// 任何 shell 树视图控件或 shell 列表视图控件。
	CShellManager *pShellManager = new CShellManager;

	// 激活“Windows Native”视觉管理器，以便在 MFC 控件中启用主题
	CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerWindows));

	// 标准初始化
	// 如果未使用这些功能并希望减小
	// 最终可执行文件的大小，则应移除下列
	// 不需要的特定初始化例程
	// 更改用于存储设置的注册表项
	// TODO:  应适当修改该字符串，
	// 例如修改为公司或组织名
	SetRegistryKey(_T("应用程序向导生成的本地应用程序"));
	// 分析自动化开关或注册/注销开关的命令行。
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// 应用程序是用 /Embedding 或 /Automation 开关启动的。
	//使应用程序作为自动化服务器运行。
	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		// 通过 CoRegisterClassObject() 注册类工厂。
		COleTemplateServer::RegisterAll();
	}
	// 应用程序是用 /Unregserver 或 /Unregister 开关启动的。  移除
	// 注册表中的项。
	else if (cmdInfo.m_nShellCommand == CCommandLineInfo::AppUnregister)
	{
		COleObjectFactory::UpdateRegistryAll(FALSE);
		AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor);
		return FALSE;
	}
	// 应用程序是以独立方式或用其他开关(如 /Register
	// 或 /Regserver)启动的。  更新注册表项，包括类型库。
	else
	{
		COleObjectFactory::UpdateRegistryAll();
		AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid);
		if (cmdInfo.m_nShellCommand == CCommandLineInfo::AppRegister)
			return FALSE;
	}
#ifdef _DEBUG
//	m_msOld.Checkpoint();
#endif  // _DEBUG

	//_CrtSetBreakAlloc(476);
	m_Data = new CData;

	TCHAR ff[32] =_T("2016-06-02 14:15:16") ;
	struct SHOW_ALM alm;

	
	//m_Data->Add_ECG_Alm(0, 1, ff, 3, 4);
	/*m_pCShowAlm->Add_ECG_Alm(5, 6, ff, 3, 4);
	m_pCShowAlm->Get_ECG_Alm(&alm,0);
	m_pCShowAlm->Del_ECG_Alm(1);
	m_pCShowAlm->Get_ECG_Alm(&alm, 0);*/

	CVerbpoDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO:  在此放置处理何时用
		//  “确定”来关闭对话框的代码
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO:  在此放置处理何时用
		//  “取消”来关闭对话框的代码
	}
	else if (nResponse == -1)
	{
		TRACE(traceAppMsg, 0, "警告: 对话框创建失败，应用程序将意外终止。\n");
		TRACE(traceAppMsg, 0, "警告: 如果您在对话框上使用 MFC 控件，则无法 #define _AFX_NO_MFC_CONTROLS_IN_DIALOGS。\n");
	}

	// 删除上面创建的 shell 管理器。
	if (pShellManager != NULL)
	{
		delete pShellManager;
	}

	// 由于对话框已关闭，所以将返回 FALSE 以便退出应用程序，
	//  而不是启动应用程序的消息泵。
	return FALSE;
}

int CVerbpoApp::ExitInstance()
{
	AfxOleTerm(FALSE);
	delete m_Data;

#ifdef _DEBUG
	//m_msNew.Checkpoint();
	//if (m_msDiff.Difference(m_msOld, m_msNew))
	//{
	//	afxDump << "\nMemory Leaked :\n";
	//	m_msDiff.DumpStatistics();
	//	afxDump << "Dump Complete !\n\n";
	//}
#endif  // _DEBUG
	return CWinApp::ExitInstance();
}

int CVerbpoApp::Get_Battery()
{
	SYSTEM_POWER_STATUS sps;
	GetSystemPowerStatus(&sps);

	m_CSBattery.Lock();
	//是否插入电源适配器
	m_i32ACFlag = sps.ACLineStatus;
	//电池电量
	m_i32BatteryLifePercent = sps.BatteryLifePercent;
	m_i32BatteryFlag = sps.BatteryFlag;
	m_CSBattery.Unlock();
	
	return 0;
}

int CVerbpoApp::Get_Battery(INT * ACFlag, INT *BatteryFlag, INT *BatteryLifePercent)
{
	m_CSBattery.Lock();
	//是否插入电源适配器
	*ACFlag = m_i32ACFlag;
	//电池电量
	*BatteryLifePercent = m_i32BatteryLifePercent;
	*BatteryFlag = m_i32BatteryFlag;
	m_CSBattery.Unlock();

	return 0;
}